Simple Two-way Active Measurement Protocol (STAMP) for MPLS Label Switched Paths (LSPs)
Internet-Draft draft-mirsky-mpls-stamp-07
Greg Mirsky
Ericsson
gregimirsky@gmail.com
2024
Routing
MPLS Working Group
Internet-Draft
LSP Ping
STAMP
Simple Two-way Active Measurement Protocol (STAMP), defined in RFC 8762 and RFC 8972, is expected to be able to monitor the performance of paths between systems that use a wide variety of encapsulations. This document defines encapsulation and bootstrapping of a STAMP test session over an MPLS Label Switched Path.
Introduction
[RFC8762] and [RFC8972] defined the base specification and extensions of the Simple Two-Way Active Measurement Protocol (STAMP). STAMP can be used to measure packet loss, and packet delay, detect packet re-ordering, and unwanted multiple copies of a STAMP packet. This document defines the encapsulation of the STAMP test message over a Multiprotocol Label Switching (MPLS ) Label Switched Path (LSP). Also, the use of LSP Ping [RFC8029] to bootstrap and control the path for the reflected STAMP test packet is discussed in the document. [RFC8762] defined two modes of a STAMP Session-Reflector - Stateful and Stateless. While using the LSP Ping extension to bootstrap a STAMP test session applies for both Session-Reflector modes, controlling the path for the reflected STAMP test packet is appropriate for the Stateful mode of the Session-Reflector only.
This document defines the Reflected Packet Path TLV as an extension to LSP Ping [RFC8029]. It is to be used to instruct the STAMP Session-Reflector how to demultiplex incoming STAMP test sessions and a path to use for the reflected STAMP test packets. The TLV will be allocated from the TLV and sub-TLV registry defined in [RFC8029]. As a special case, forward and reverse directions of the STAMP test session can form a bi-directional co-routed associated channel.
Conventions Used in this Document

Acronyms
STAMP: Simple Tw-way Active Measurement Protocol
MPLS: Multiprotocol Label Switching
LSP: Label Switching Path
SSID: STAMP Session Identifier
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Encapsulation of a STAMP Test Packet
STAMP can be used to measure one-way packet loss and packet delay, and detect packet re-ordering, and unwarranted replication of a STAMP test packet. [RFC8762] defined formats of a STAMP test packet and reflected STAMP test packet in unauthenticated and authenticated modes, respectively. These STAMP test packets can be encapsulated in IP/UDP to be transmitted over an MPLS LSP as follows:
- The STAMP test packet sent by the ingress LSR SHOULD be a UDP packet with a well-known destination port 862 [RFC8762] and a source port assigned by the sender. The destination UDP port MAY be selected from the Dynamic UDP ports range. The mechanism used to select the port number from the Dynamic range is outside the scope of this document.
- The destination IP address MUST be randomly chosen from the 127/8 range for IPv4. For IPv6, the ::1/128 address MUST be used.
- For the STAMP test packet, the sender MUST set the IP TTL or hop limit to 255 [RFC5082].
- The source IP address is a routable address of the sender.
- The reflected STAMP test packets are UDP packets.
- The source IP address of a reflected STAMP test packet is a routable address of the STAMP Session-Reflector.
Bootstrap STAMP Using LSP Ping
A STAMP test session over an MPLS LSP can be bootstrapped using LSP Ping, defined in [RFC8029]. To bootstrap a STAMP test session, STAMP Session Identifier TLV MUST be used. When LSP Ping is used to bootstrap a STAMP test session, the Reply Mode field SHOULD be set to "Reply via an IPv4/IPv6 UDP packet" (2) value. In some environments, e.g., point-to-multipoint LSP, the Reply Mode field MAY be set to "Do not reply" (1). The value of the Reply Mode field MUST NOT be set to "Reply via an IPv4/IPv6 UDP packet with Router Alert" (3) [I-D.kompella-mpls-lspping-norao]. This document defines a new SSID TLV. The STAMP Session Identifier TLV MUST contain the STAMP Session Identifier (SSID) [RFC8972] value and MAY contain none, one or more sub-TLVs that can be used to carry information about the path for reflected STAMP test packet.
STAMP Session Identifier TLV
The STAMP Session Identifier TLV is an optional TLV within the LSP Ping [RFC8029]. The STAMP Session Identifier TLV carries SSID value and, optionally, information about the path onto which the STAMP Session-Reflector MUST transmit reflected STAMP test packets for the given STAMP test session. The format of the STAMP Session Identifier TLV is as presented in Figure 1.
STAMP Session Identifier TLV

  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |   STAMP Session Id TLV Type   |           Length              |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                             SSID                              |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  UDP Destination Port Number  |           Reserved            |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 ~               Reflected Packet Path  (optional)               ~
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

STAMP Session Identifier Type is a two-octet field and has a value of TBD1 (to be assigned by IANA as requested in Section 5).
Length field is a two-octet field equal to the length in octets of the SSID, UDP Destination Port Number, Reserved, and Reflected Packet Path fields. The minimum value MUST be eight.
SSID field is a four-octet field that identifies the STAMP test session at the STAMP Session-Sender.
UDP Destination Port Number is a two-octet field. The field indicates the value of the UDP destination port in test packet transmitted by the Session-Sender for the test session with SSID. The Session-Sender MAY set the value of the field to 862 that is assigned by IANA as TWAMP-Test Receiver Port. If the value of the field is not equal to862 then it MUST be one from the range of Dynamic ports, i.e., from 49152 to 65535. Any other value of the UDP Destination Port Number field is invalid and the Session-Reflector MUST send an Echo Reply message with the received STAMP Session Identifier TLV and set te Return Code field to "UDP Destination Port Unavailable" (Section 5.2).
Reserved is a two-octet field. It MUST be zeroed on transmission and ignored on reciept.
Reflected Packet Path field contains none, one or more sub-TLVs. Any Target FEC Stack sub-TLV (already defined, or to be defined in the future) for TLV Types 1, 16, and 21 of MPLS LSP Ping Parameters registry group's TLVs and sub-TLVs registry MAY be used in this field. The Non-FEC Path TLV, defined in [I-D.ietf-spring-bfd], MAY be used to specify the path for a STAMP reflected test packet in the SR-MPLS environment. None, one or more sub-TLVs MAY be included in the Reflected Packet Path TLV. If no sub-TLVs are found in the STAMP Session Identifier TLV, the STAMP Session-Reflector MUST revert to transmitting the STAMP reflected packets over the IP network.
If the STAMP Session-Reflector cannot find the path specified in the Reflected Packet Path TLV, it MUST send Echo Reply with the received STAMP Session Identifier TLV and set the Return Code to "The specified Reflected Packet Path was not found" (Section 5.2).
The STAMP Session Identifier TLV MAY be used in the bootstrapping of a STAMP test session. A STAMP Session-Reflector that supports this specification MUST support subsequent STAMP Session Identifier TLVs after the STAMP test session with the given SSID has been established. The system that receives a new path as sub-TLVs in the Reflected Packet Path field for the established STAMP test session MUST use the new path for the reflected STAMP test packets. Suppose a system that supports this specification receives an LSP Ping with the STAMP Session Identifier TLV with no sub-TLVs in the Reflected Packet Path field, even though the reflected test packets for the specified STAMP test session has been transmitted according to the previously received STAMP Session Identifier TLV. In that case, the egress LSR MUST transition to transmitting reflected STAMP packets over an IP network.
Return Codes
This document defines the following Return Codes for MPLS LSP Echo Reply:
- "The specified Reflected Packet Path was not found", (TBD2). When a specified reverse path is not available at the STAMPSession-Reflector an Echo Reply with the Return Code set to "The specified Reflected Packet Path was not found" MUST be sent back to the STAMP Session-Sender Section 3.1.
- "UDP Destination Port Unavailable" (TBD3). If the value of the Destination UDP Port Number field is not 862, nor is from the Dynamic ports range, the Session-Reflector MUST send an Echo Reply to the Session-Sender with the Return Code set to "UDP Destination Port Unavailable".
STAMP Session Establishment
A STAMP test session can be bootstrapped using LSP Ping. To monitor performance for a particular MPLS LSP and FEC combination LSP Ping Echo request and Echo reply packets, in the ping mode, exchanged between the STAMP Session-Sender and Session-Reflector for that MPLS LSP and FEC combination. If LSP Ping is used to establishing a STAMP test session, an LSP Ping Echo request message MUST carry the SSID value assigned by the Session-Sender for the STAMP test session. This MUST subsequently be used as the SSID field in the STAMP test session packets sent by the STAMP Session-Sender.
On receipt of the LSP Ping Echo request message, the STAMP Session-Reflector MUST send an LSP Ping Echo response if the validation of the FEC in the LSP Ping Echo request message succeeds. The Session-Reflector SHOULD use the value in the SSID field and source IP address in the received LSP Ping Echo request message to demultiplex STAMP test sessions. The Session-Reflector MAY use a combination of other values in IP/UDP headers instead of using SSID to demultiplex STAMP test sessions.
If the MPLS network includes an equal-cost multipath environment, a STAMP Session-Sender MUST use the same value of an Entropy Label ([RFC6790] and [RFC8662]) in the LSP Ping Echo request that bootstraps the STAMP test session and consecutive STAMP test packets.
IANA Considerations
STAMP Session Identifier TLV
The IANA is requested to assign a new value for the STAMP Session Identifier TLV from the "Multiprotocol Label Switching Architecture (MPLS) Label Switched Paths (LSPs) Ping Parameters - TLVs" registry group, "TLVs and sub-TLVs" registry.
New BFD Reverse Type TLV
Value | Description | Reference
(TBD1) | STAMP Session Identifier TLV | This document
Return Code
The IANA is requested to assign a new Return Code value from the "Multi-Protocol Label Switching (MPLS) Label Switched Paths (LSPs) Ping Parameters" registry group's "Return Codes" registry, as follows using a Standards Action value.
New Return Code
Value | Description | Reference
(TBD2) | The specified Reflected Packet Path was not found. | This document
(TBD3) | UDP Destination Port Unavailable. | This document
Security Considerations
Security considerations discussed in [RFC8029], [RFC8762], and [RFC8972] apply to this document.
Acknowledgments
The author sincerely appreciates Richard "Footer" Foote's thoughtful comments.
References
Normative References
Informational References
[RFC8762]
[RFC8972]
[RFC8029]
[RFC2119]
[RFC8174]
[RFC5082]
[I-D.kompella-mpls-lspping-norao]
[I-D.ietf-spring-bfd]
[RFC6790]
[RFC8662]